package game;
                                                              
                                                                                                                
/*
 * This code is protected under the Gnu General Public License (Copyleft), 2005 by
 * IBM and the Computer Science Teachers Association. It may be freely
 * modified and redistributed under educational fair use.
 * 
 * 
 * USED FAIRLY BY JASON STEWART.
 */

import java.awt.Color;



import java.util.Random;
import javax.sound.sampled.*;

import javax.swing.*;

import java.awt.event.*;


public class Pong extends Game {
     
public static String NAME = "Sound";
private Sound sound; 

    
		public static final int WINNING_SCORE = 10;
	  
		Paddle top = new Paddle();
		Paddle bottom = new Paddle();
		Ball ball = new Ball();
		Random rand = new Random();
		JLabel p1Score = new JLabel("Uno");
		JLabel p2Score = new JLabel("Dos");
		JLabel p1 = new JLabel();
		JLabel p2 = new JLabel();
		int p1S = 0;
		int p2S = 0;
		
		int ball_Speed = Ball.speed;
		static double speed_Mult = 0;
		
		int pad_Length = top.getWidth();
		static double pad_Exten = 0;
		
		JMenu game = new JMenu("Game");
		JMenu info = new JMenu("Info");		
	
		
		JMenuItem restart = new JMenuItem("DO-OVER");
		JMenuItem pause = new JMenuItem("STOP TIME");
		JMenuItem resume = new JMenuItem("TIME RESUMES");

	
	public void setup() {
		
                top.setSize(100,20);
		top.setX((getFieldWidth() / 2) - (top.getWidth() / 2));
                //top.setY(getFieldHeight() - bottom.getHeight()); adding this made it bug out, so it wasnt needed.
                top.setColor(Color.PINK);
            
            
            
                bottom.setSize(100,20);
		bottom.setX((getFieldWidth() / 2) - (bottom.getWidth() / 2));
		bottom.setY(getFieldHeight() - bottom.getHeight());
                bottom.setColor(Color.PINK);
            
            
                ball.setSize(20,20);
		ball.setXVelocity(Ball.speed);
		ball.setYVelocity(Ball.speed);
		ball.setX((getFieldWidth() / 2) - (ball.getX() / 2));
		ball.setY((getFieldHeight() / 2)  - (ball.getY() / 2));
		ball.setColor(Color.MAGENTA);
		
		
		
              		
		p1Score.setSize(50,30);
                p1Score.setLocation(getFieldWidth() - getFieldWidth(), getFieldHeight() - getFieldHeight());
                p1Score.setHorizontalTextPosition(SwingConstants.CENTER);
                p1Score.setVerticalTextPosition(SwingConstants.CENTER);
                
                p1.setSize(80, 50);
                p1.setLocation(getFieldWidth() - getFieldWidth(), (getFieldHeight() - getFieldHeight()) + top.getHeight());
                
                
		p2Score.setSize(50,30);
		p2Score.setLocation(getFieldWidth() - p2Score.getWidth(), getFieldHeight() - getFieldHeight());		
		p2Score.setHorizontalTextPosition(SwingConstants.CENTER);
		p2Score.setVerticalTextPosition(SwingConstants.CENTER);
		
		
		p2.setSize(80, 50);
		p2.setLocation(getFieldWidth() - p2.getWidth(), (getFieldHeight() - getFieldHeight()) + top.getHeight());
            
		getJMenuBar().add(game);
                game.add(restart);
                restart.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				restart();
			}
		});//CODE FOR THE RESTART BUTTON
                
		game.add(pause);
                pause.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				stopGame();
			}
		});//CODE FOR THE PAUSE BUTTON
                
		game.add(resume);
		resume.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				startGame();
			}
		});//CODE FOR THE RESUME BUTTON
		
		
		

		add(top);
		add(bottom);
		add(ball);
		
		add(p1Score);
		add(p2Score);
		
		add(p1);
		add(p2);
		
		setDelay(10);
                
	}
	
	
	public void act() {
		press();
		//release(); //removed release to make the game my own
		collide();
		scorekeeper();
                
	}
	
	

	public void press(){ //KEYPRESSES!!!!!!!!!
		if(ZKeyPressed()){
			top.setXVelocity(Paddle.speed * -1);
		}
		
		if(XKeyPressed()){
			top.setXVelocity(Paddle.speed);
		}
		
		if(NKeyPressed()){ //edited game.java to allow 1 for n
			bottom.setXVelocity(Paddle.speed * -1);
		}
		
		if(MKeyPressed()){ //edited game.java vto allow 2 for m
			bottom.setXVelocity(Paddle.speed);
		}
	}
	
	
	public void release(){ //handles key releases, but I removed this to make the game my own
		if(!ZKeyPressed() && !XKeyPressed()){
			top.setXVelocity(0);
		}
		
		if(!NKeyPressed() && !MKeyPressed()){
			bottom.setXVelocity(0);
		}
	}
	
	
	public void collide(){ //handles collission
		
		
		if(top.getX() <= 0){ //stops paddle from going out of bounds
			top.setX(top.getX() + 1);	
			top.setXVelocity(0);
		}
		
		if((top.getX() + top.getWidth()) >= getFieldWidth()){//stops paddle from going out of bounds
			top.setX(top.getX() - 1);
			top.setXVelocity(0);
		}
		
		if(bottom.getX() <= 0){ //stops paddle from going out of bounds
			bottom.setX(bottom.getX() + 1);
			bottom.setXVelocity(0);
		}
		
		if((bottom.getX() + bottom.getWidth()) >= getFieldWidth()){ //stops paddle from going out of bounds
			bottom.setX(bottom.getX() - 1);
			bottom.setXVelocity(0);
		}
		
		if(ball.collides(top) || ball.collides(bottom)){ //ball to paddle collision
		
			ball.setYVelocity(ball.getYVelocity() * -1);
		}
		
		if(ball.getX() <= 0 || (ball.getX() + ball.getWidth()) > getFieldWidth()){ //sets rules for window collision with ball
			ball.setXVelocity(ball.getXVelocity() * -1);

		}
	}
	
	public void scorekeeper(){ //sets rules for if ball goes past paddle
		
				if((ball.getY() + ball.getHeight()) > getFieldHeight()){
				//Player 2 
					reset();
					p2S ++;
						if(p2S == WINNING_SCORE){                                                 
							stopGame();
							p2Wins();       
						}
				}
				if(ball.getY() <= 0){
				//Player 1 
					reset();
					p1S ++;
						if(p1S == WINNING_SCORE){
							stopGame();
							p1Wins();
       						}
				}
		
		p1.setText(Integer.toString(p1S)); //keeps scores 
		p2.setText(Integer.toString(p2S)); //keeps scores
				
	}
	
	public void reset(){ //resets the ball for a new round
		top.setX((getFieldWidth() / 2) - (top.getWidth() / 2));
		top.setY(0);
		
		bottom.setX((getFieldWidth() / 2) - (bottom.getWidth() / 2));
		bottom.setY(getFieldHeight() - bottom.getHeight());
		
		int x = Ball.speed;
		int y = Ball.speed;
		rand.setSeed(System.currentTimeMillis());
		
                if ((rand.nextInt() % 2) == 0 )
                {
                   x = Ball.speed; 
                }
                
                else
                {
                    x = Ball.speed *-1;
                }
               
                
                 if ((rand.nextInt() % 2) == 0 )
                {
                   y = Ball.speed; 
                }
                
                else
                {
                    y = Ball.speed * -1;
                }	
		
		ball.setX((getFieldWidth() / 2) - (ball.getWidth() / 2));
		ball.setY((getFieldHeight() / 2) - (ball.getHeight() / 2));
		
		ball.setXVelocity(x);
		ball.setYVelocity(y);
	}
	public void run(){
            
        }
       
        
        public void init()
    {
        Sound.sound1.play();
    }
        
	public void restart(){ //resets scores for a new game		
		p1S = 0;
		p2S = 0;
                init();
		reset();
		startGame();
                //restart sets scores to zero, uses reset then starts game.
	}
	
	public static void main(String[] args) {
            /* sound = new File("priceisright.wav");
            new Thread(play).start(); */
		Pong p = new Pong();
		p.setVisible(true);
		p.initComponents();
         //was told to leave this alone      
	}
}